459

Sometimes I want to start a process and forget about it. If I start it from the command line, like this:

redshift

I can't close the terminal, or it will kill the process. Can I run a command in such a way that I can close the terminal without killing the process?

3
  • 5
    Not a default install on all distros, but screen is your friend: en.wikipedia.org/wiki/GNU_Screen Nov 13, 2010 at 14:23
  • 7
    To anyone facing the same problem: Remember, that even if you type yourExecutable & and the outputs keep coming on the screen and Ctrl+C does not seem to stop anything, just blindly type disown; and press Enter even if the screen is scrolling with outputs and you can't see what you're typing. The process will get disowned and you'll be able to close the terminal without the process dying.
    – Nav
    Apr 21, 2016 at 11:18
  • 1
    You can use screen multiplexer such tmux. It is available via apt-get on ubuntu machines
    – Himanshu
    May 5, 2016 at 11:17

11 Answers 11

472

One of the following 2 should work:

$ nohup redshift &

or

$ redshift &
$ disown

See the following for a bit more information on how this works:

13
  • 9
    The second one (redshift & disown) worked for me on Ubuntu 10.10. It seems to work fine putting it all on one line. Is there any reason that I shouldn't do this?
    – Matthew
    Nov 13, 2010 at 0:52
  • 5
    @Matthew The first should work fine too, it just doesn't background like the second (you possibly want nohup redshift & so it does background). And putting the second on one line is fine, although usually you separate with ; (redshift &; disown) Nov 13, 2010 at 3:14
  • 13
    @Michael: Both ; and & are command separators and have equal precedence. The only difference is the synchronous versus asynchronous execution (respectively). There is no need to use &; in preference to just & (it works, but it is a bit redundant). Nov 13, 2010 at 4:29
  • 6
    good answer, one might add that it would be a good idea to redirect stdout and stderr so that the terminal won't be spammed with debug output
    – Kim
    Nov 13, 2010 at 6:22
  • 23
    Also, redshift &! will disown redshift immediately.
    – user26112
    Apr 21, 2013 at 18:30
176

If your program is already running you can pause it with Ctrl-Z, pull it into the background with bg and then disown it, like this:

$ sleep 1000
^Z
[1]+  Stopped                 sleep 1000
$ bg
$ disown
$ exit
10
  • 4
    after disown how can I again read the stdout of the running process?
    – Necktwi
    May 22, 2014 at 10:59
  • 2
    @neckTwi, serverfault.com/questions/55880/…
    – Stefan
    May 22, 2014 at 11:23
  • 2
    @necktwi disown does not disconnect stdout or stderr. However nohup does, as does >/dev/null (disconnect standard out), 2>/dev/null (disconnect standard error). It (disown) disconnects job-control. Jul 21, 2016 at 22:08
  • 2
    To anyone else finding this, this really messed things up for me so be careful. Ctrl+z stopped it just fine, but bg made it start running again and now it won't respond to Ctrl+Z or Ctrl+C. Now there seems to be no way to exit the running command safely at all. No idea why, just did exactly what it said, but for whatever reason bg bought it back running. I can't do the next step of typing disown because there's too much output to type anything. Sep 20, 2017 at 15:47
  • 2
    @JohnMellor You were probably running into a similar situation to ctrl-alt-delor's comment, where the program is indeed running in the background but still has its stdout piped to your shell. Ctrl + C and Ctrl + Z won't do anything from here because no program is actually running in the foreground. You can still type in commands from here, like ls or disown without a problem, it is just really hard to read what you're typing while output is being mixed in with your characters. I just had a similar situation with ffmpeg, but it works fine. Jul 22, 2019 at 21:46
60

Good answer is already posted by @Steven D, yet I think this might clarify it a bit more.

The reason that the process is killed on termination of the terminal is that the process you start is a child process of the terminal. Once you close the terminal, this will kill these child processes as well. You can see the process tree with pstree, for example when running kate & in Konsole:

init-+
     ├─konsole─┬─bash─┬─kate───2*[{kate}]
     │         │      └─pstree
     │         └─2*[{konsole}]

To make the kate process detached from konsole when you terminate konsole, use nohup with the command, like this:

nohup kate &

After closing konsole, pstree will look like this:

init-+
     |-kate---2*[{kate}]

and kate will survive. :)

An alternative is using screen/tmux/byobu, which will keep the shell running, independent of the terminal.

3
  • I had problems with the disown methods. This is currently working for me, so upvoting. I also like this because I can tail -f nohup.out to see whats happening, but not worry about my session failing
    – Ian
    Apr 17, 2015 at 13:44
  • so after nohup or disown, how do you get the process back? or get access to old stdout?
    – fotoflo
    Mar 6, 2021 at 13:00
  • Thank you very much for the recommendation screen/tmux/byobu.
    – spaceman
    Mar 17, 2023 at 17:26
39

You can run the process like this in the terminal

setsid process

This will run the program in a new session, as explained in my article here.

5
  • 1
    What do you see as the advantages of setsid over nohup?
    – itsbruce
    Oct 30, 2012 at 10:52
  • 2
    1) It doesn't print an annoying message about nohup.out. 2) It doesn't remain in your shell's job list, so it doesn't clutter the output of jobs.
    – Mikel
    Nov 6, 2012 at 22:24
  • 2
    This is the only solution that worked for with script that runs in lxterminal, launchs pcmanfm and exit (with setsid the terminal can close while pcmanfm keep running). Thank you so much!
    – desgua
    May 9, 2019 at 14:48
  • It works for tint2, thanks
    – kokbira
    Nov 29, 2019 at 11:32
  • Similar to desgua said with my Fedora GNOME install. Running a script to open other applications through my fish shell and a desktop application wrapper. nohup, open, xdg-open were not helping, even with the ampersand (&) and verifying in System Monitor in dependencies/hierarchy/family/tree mode that my new process was not a parent of the originally spawning-shell under gnome-terminal-server that was consistent with non- and actually- -working approaches.
    – Pysis
    Mar 15, 2022 at 20:14
17

I prefer:

(applicationName &)

for example: linux@linux-desktop:~$ (chromium-browser &)

Make sure to use parenthesis when type the command!

5
  • 1
    Probably you have prompt command that I've used in my answer without parenthesis, if so closing the terminal will kill the process, otherwise it will NOT happen. I've already edited the solution above to make it clear.
    – daGo
    Nov 30, 2016 at 7:13
  • 2
    I am wondering why this got not more upvotes. nohup prevents any tty output and I actually just wanted redirect the output to a file and it prevented that so this is the better solution to me. Dec 3, 2018 at 4:06
  • 1
    extremely interesting. clean and uses no additional command. it even plays nicely with sudo.
    – brett
    Mar 22, 2020 at 19:13
  • 1
    Outstanding! I've never been able to figure out how to open apps/files/resources/etc and advance the shell prompt from a single command, until now. So thank you. Can you elaborate on how the shell interprets (command &) vs command &. Why does the latter wait for more input? Also, if I want to immediately close the terminal after opening a gui app, is it enough to just pass something like (nautilus path/to/foo/bar/ &) ; exit; to the shell? Just want to make sure I am not introducing any new problems. Jan 17, 2021 at 3:55
  • 1
    @NicholasCousar I'm not sure how other shells interpret (...) but in Bash that runs ... in a subshell. (It might be a POSIX standard.) Oct 28, 2021 at 2:37
15

Though all of the suggestions work well, I've found my alternative is to use screen, a program that sets up a virtual terminal on your screen.

You might consider starting it with screen -S session_name. Screen can be installed on virtually all Linux and Unix derivatives. Hitting Ctrl+A and (lower case) C will start a second session. This would allow you to toggle back and forth between the initial session by hitting Ctrl+A and 0 or the newer session by hitting Ctrl+A and 1. You can have up to ten sessions in one terminal. I used to start a session at work, go home, ssh into my work machine, and then invoke screen -d -R session_name. This will reconnect you to that remote session.

1
  • screen -d -m command will start it within already detached screen: ~# screen -d -m top ~# screen -ls There is a screen on: 10803..Server-station (Detached) 1 Socket in /root/.screen. ~# screen -x .... and you're in. May 15, 2019 at 6:30
10
+50

I have a script (I called run) to:

  • Run arbitrary commands in the background
  • Stop them from being killed with the terminal window
  • Suppress their output
  • Handles exit status

I use it mainly for gedit, evince, inkscape etc that all have lots of annoying terminal output. If the command finishes before TIMEOUT, nohup's exit status is returned instead of zero. Contents of run:

#!/bin/bash

TIMEOUT=0.1

#use nohup to run the command, suppressing its output and allowing the terminal to be closed
#also send nohup's output to /dev/null, supressing nohup.out
#run nohup in the background so this script doesn't block
nohup "${@}" >/dev/null 2>&1 &
NOHUP_PID=$!

#kill this script after a short time, exiting with success status - command is still running
#this is needed as there is no timeout argument for `wait` below
MY_PID=$$
trap "exit 0" SIGINT SIGTERM
sleep $TIMEOUT && kill $MY_PID 2>/dev/null & #ignore "No such process" error if this exits normally

#if the command finishes before the above timeout, everything may be just fine or there could have been an error
wait $NOHUP_PID
NOHUP_STATUS=$?
#print an error if there was any. most commonly, there was a typo in the command
[ $NOHUP_STATUS != 0 ] && echo "Error ${@}"
#return the exit status of nohup, whatever it was
exit $NOHUP_STATUS

Examples:

>>> run true && echo success || echo fail
success
>>> run false && echo success || echo fail
Error false
fail
>>> run sleep 1000 && echo success || echo fail
success
>>> run notfound && echo success || echo fail
Error notfound
fail
9

The shell-only way to do all this is to close stdin and background the command:

command <&- & 

Then it won't quit when you quit the shell. Redirecting stdout is a nice optional thing to do.

Disadvantage is that you can't do this after the fact.

1
  • I tried in ubuntu. Killing terminal also closed the launched process. Any idea on why this might be the case?
    – Ashok Koyi
    Nov 30, 2017 at 10:57
5

You can set a process (PID) to not receive a HUP signal upon logging out and closing the terminal session. Use the following command:

nohup -p PID
4

Arguably similar to the answer offered by apolinsky, I use a variant on screen. The vanilla command is like this

screen bash -c 'long_running_command_here; echo; read -p "ALL DONE:"'

The session can be disconnected with Ctrl ACtrl D and reconnected in the simple case with screen -r. I have this wrapped in a script called session that lives in my PATH ready for convenient access:

#!/bin/bash
#
if screen -ls | awk '$1 ~ /^[1-9][0-9]*\.'"$1"'/' >/dev/null
then
    echo "WARNING: session is already running (reattach with 'screen -r $1')" >&2
else
    exec screen -S "$1" bash -c "$@; echo; echo '--------------------'; read -p 'ALL DONE (Enter to exit):'"
    echo "ERROR: 'screen' is not installed on this system" >&2
fi
exit 1

This only works when you know in advance you want to disconnect a program. It does not provide for an already running program to be disconnected.

3

Similarly to other answers posted before, one can transfer a running process to use screen retrospectively thanks to reptyr and then close the terminal. The steps are described in this post. The steps to take are:

  1. Suspend the process
  2. Resume the process in the background with bg
  3. disown the process
  4. Launch a screen session
  5. Find the PID of the process
  6. Use reptyr to take over the process

You must log in to answer this question.

Not the answer you're looking for? Browse other questions tagged .